unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, CPort, CPortCtl, Forms, Controls, Graphics,
  Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Bt_PortSettings: TButton;
    Bt_OpenPort: TButton;
    Bt_SendData: TButton;
    Bt_Quit: TButton;
    ComLedTx: TComLed;
    ComLedRx: TComLed;
    ComPort1: TComPort;
    Ed_Data: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    procedure Bt_OpenPortClick(Sender: TObject);
    procedure Bt_PortSettingsClick(Sender: TObject);
    procedure Bt_QuitClick(Sender: TObject);
    procedure Bt_SendDataClick(Sender: TObject);
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
  private
    { private declarations }
    CurPos : integer;
    FTempStr: String;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Bt_PortSettingsClick(Sender: TObject);
begin
    ComPort1.ShowSetupDialog;
    Bt_OpenPort.Enabled := True;
    Bt_OpenPort.Caption := 'Open Port';
    Bt_SendData.Enabled := False ;
end;

procedure TForm1.Bt_QuitClick(Sender: TObject);
begin
      if ComPort1.Connected then ComPort1.Close;
Application.Terminate;
end;

procedure TForm1.Bt_SendDataClick(Sender: TObject);
begin
    ComPort1.WriteStr(Ed_Data.Text + #13#10);
end;


procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
  var Str: String;
begin
  ComPort1.ReadStr(Str, Count);
  CurPos := Pos( Char(10) ,Str);
  if CurPos = 0 then begin
    FTempStr := FTempStr + Str;
  end
  else begin
    FTempStr := FTempStr + Copy( Str, 1, CurPos-1);
    Memo1.Lines.Append(FTempStr);
    FTempStr := Copy(Str,CurPos +1, Count - CurPos);
  end;
end;

procedure TForm1.Bt_OpenPortClick(Sender: TObject);
begin
  try
    if ComPort1.Connected then ComPort1.Close
    else   ComPort1.Open;
  Bt_OpenPort.Enabled := False;
  Bt_OpenPort.Caption := 'Port ' + ComPort1.Port + ' in use';
  Bt_SendData.Enabled := True ;
  except
  on E : Exception do
      ShowMessage(E.ClassName+' error raised, with message : '+E.Message);
  end;
end;

end.

